﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace exercabstracao
{
    class Programa
    {

        public abstract class FormaGeometrica
        {
            public abstract double area();
            public abstract double perimetro();
        }

        public class TrianguloRetangulo : FormaGeometrica
        {
            private double catetobase { get; set; }
            private double catetoaltura { get; set; }
            private double hipotenusa { get; set; }

            public TrianguloRetangulo()
            {
                Console.WriteLine("Dados do triângulo retângulo: ");
                Console.Write("Informe o valor da base: ");
                this.catetobase = Convert.ToDouble(Console.ReadLine());
                Console.Write("Informe o valor da altura: ");
                this.catetoaltura = Convert.ToDouble(Console.ReadLine());
                this.hipotenusa = Math.Sqrt(Math.Pow(this.catetobase, 2) + Math.Pow(this.catetoaltura, 2));
                Console.WriteLine("A hipotenusa vale {0}", this.hipotenusa);
            }
            
            public override double area()
            {
                return (this.catetobase * this.catetoaltura)/2;
            }

            public override double perimetro()
            {
                return this.catetobase+this.catetoaltura+this.hipotenusa;
            }
        }

        public class Circulo : FormaGeometrica
        {
           private double raio { get; set; }

            public Circulo()
            {
                Console.WriteLine("Dados do Cículo");
                Console.Write("Informe o valor do raio do círculo: ");
                this.raio = Convert.ToDouble(Console.ReadLine());
            }
            
            public override double area()
            {
                return Math.PI * Math.Pow(this.raio, 2);
            }

            public override double perimetro()
            {
                return 2 * Math.PI * this.raio;
            }
        }

        public class Retangulo : FormaGeometrica
        {
            private double catetobase { get; set; }
            private double catetoaltura { get; set; }

            public Retangulo()
            {
                Console.WriteLine("Dados do retângulo: ");
                Console.Write("Informe o valor da base: ");
                this.catetobase = Convert.ToDouble(Console.ReadLine());
                Console.Write("Informe o valor da altura: ");
                this.catetoaltura = Convert.ToDouble(Console.ReadLine());
            }

            public override double area()
            {
                return this.catetobase * this.catetoaltura;
            }

            public override double perimetro()
            {
                return 2 * this.catetobase + 2 * this.catetoaltura;
            }
        }

        
        static void Main()
        {
            TrianguloRetangulo teste = new TrianguloRetangulo();
            Console.WriteLine("A área do triângulo retângulo é {0}", teste.area());
            Console.WriteLine("O perímetro do triângulo retângulo é {0}", teste.perimetro());
            Circulo teste2 = new Circulo();
            Console.WriteLine("A área do círculo é {0}",teste2.area());
            Console.WriteLine("O perímetro do círculo é {0}", teste2.perimetro());
            Retangulo teste3 = new Retangulo();
            Console.WriteLine("A área do retângulo é {0}", teste3.area());
            Console.WriteLine("O perímetro do retângulo é {0}", teste3.perimetro());
            Console.ReadKey();
        }
    }
}
